## metastore 1+20080623+debian

=== debian/changelog ===
metastore (1+20080623+debian-5) unstable; urgency=medium

  * Fix historical inaccuracy in debian/copyright; license is GPL-2, not
    GPL-2 or later, thanks to Dan Fandrich (closes: #767983).
  * Bump Standards-Version to 3.9.6, no changes needed.

 -- Romain Francoise <rfrancoise@debian.org>  Sun, 24 May 2015 12:04:54 +0200

metastore (1+20080623+debian-4) unstable; urgency=medium

  * Bump Standards-Version to 3.9.5, no changes needed.
  * Set myself as sole maintainer.
  * Mention the word "backup" in long description (thanks, Eduard Bloch).

 -- Romain Francoise <rfrancoise@debian.org>  Sat, 16 Aug 2014 18:02:30 +0200

metastore (1+20080623+debian-3) unstable; urgency=low

  * Handle xattrs with empty value correctly; thanks to Przemysław Pawełczyk
    (closes: #676572, LP: #937306).
  * Switch to debhelper compat level 9.
  * Enable all hardening options.
  * Don't overwrite environment CFLAGS, use CPPFLAGS.
  * Bump Standards-Version to 3.9.3, no changes needed.

 -- Romain Francoise <rfrancoise@debian.org>  Sun, 10 Jun 2012 17:42:59 +0200

metastore (1+20080623+debian-2) unstable; urgency=low

  * New maintainer (closes: #540588).
  * Fix getopt parsing of -f (closes: #594134).
  * Remove prompting from example Git pre-commit hook (closes: #469250);
    hooks now run with stdin closed (since Git version 1.5.4) and
    prompting will not work when using a high-level interface such as
    git-gui or Emacs anyway.
  * Switch (back) to a minimal rules files; restores missing examples.
  * Switch to source format 3.0 (quilt).
  * Add debian/watch.
  * Bump Standards-Version to 3.9.1, no changes needed.

 -- Romain Francoise <rfrancoise@debian.org>  Sun, 12 Sep 2010 10:56:36 +0200

metastore (1+20080623+debian-1) unstable; urgency=low

  * Orphaning package.

 -- Daniel Baumann <daniel@debian.org>  Sun, 09 Aug 2009 01:16:56 +0200

metastore (1+20080623+debian) unstable; urgency=low

  * New maintainer (Closes: #486897).
  * New upstream checkout, tarball built without debian directory.
  * Replacing package descriptions with text from Davids homepage.
  * Upgrading package to standards 3.8.0.
  * Seting correct value for homepage field.
  * Adding ${misc:depends} to depends.
  * Adding/Updating vcs fields.
  * Rewriting copyright in machine-interpretable format.
  * Removing unused dirs debhelper.
  * Rewriting rules file in traditional way.

 -- Daniel Baumann <daniel@debian.org>  Fri, 19 Sep 2008 13:06:00 +0200

metastore (1-4) unstable; urgency=low

  * debhelper v7; rules file minimisation
  * Orphaned the package.

 -- Joey Hess <joeyh@debian.org>  Wed, 18 Jun 2008 16:16:15 -0400

metastore (1-3) unstable; urgency=low

  * detect nonexistant users/groups and print a warning message that
    includes the pathname
  * Merge upstream changes through ed7e4217e2eae466bab88cd425c71ac22a0340c5:
    - First stab at supporting the option of automatically creating empty
      directories which are missing. Closes: #460998
    - Detect whether the underlying FS supports xattrs. Closes: #470184

 -- Joey Hess <joeyh@debian.org>  Thu, 20 Mar 2008 21:34:51 -0400

metastore (1-2) unstable; urgency=low

  * Fix man page to document --compare. Closes: #451313
  * Correct display of usage message.

 -- Joey Hess <joeyh@debian.org>  Thu, 15 Nov 2007 12:11:25 -0500

metastore (1-1) unstable; urgency=low

  * Initial upload to Debian.

 -- Joey Hess <joeyh@debian.org>  Mon, 05 Nov 2007 23:01:52 -0500

metastore (1) unstable; urgency=low

  * Initial release.

 -- David Härdeman <david@hardeman.nu>  Sat, 19 May 2007 23:20:28 +0200
