=== debian/control ===
Source: metastore
Section: misc
Priority: optional
Maintainer: Romain Francoise <rfrancoise@debian.org>
Build-Depends: debhelper (>= 9), libattr1-dev
Standards-Version: 3.9.6
Homepage: http://david.hardeman.nu/software.php

Package: metastore
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Store and restore metadata from a filesystem
 metastore is a tool to store the metadata of files/directories/links in
 a file tree to a separate file and to later compare and apply the
 stored metadata to said file tree.
 .
 The tool was written as a supplement to git which does not store all
 metadata, making it unsuitable for e.g. storing /etc in a repo.
 .
 metastore can also be helpful in a backup script if you want to create
 a tarball of a file tree and make sure that "everything" (e.g. xattrs,
 mtime, owner, group) is stored along with the files.
