=== debian/changelog ===
metastore (1.1.1a-1) unstable; urgency=medium

  * New upstream release from new maintainer (closes: #883539):
    + Fixes issue with xattrs (closes: #798222).
    + Adds new --dump option (closes: #508743).
  * Assorted packaging changes:
    + Drop all old Debian patches.
    + Add new patch to allow overriding PREFIX in upstream Makefile.
    + Set PREFIX when calling dh_auto_install.
    + Add new build-dep on libbsd-dev.
    + Install FILEFORMAT file as documentation.
    + Add new maintainer's GPG key to debian/upstream/signing-key.asc.
    + Update debian/copyright.
    + Update upstream homepage URL.
    + Update watch file and enable signature checking.
  * Add Vcs-Browser and Vcs-Git fields pointing to new repository on
    salsa.debian.org.
  * Switch to debhelper compatibility level 11.
  * Bump Standards-Version to 4.1.3.

 -- Romain Francoise <rfrancoise@debian.org>  Tue, 02 Jan 2018 19:06:04 +0100
