=== debian/control ===
--- 
+++ 
@@ -2,13 +2,18 @@
 Section: misc
 Priority: optional
 Maintainer: Romain Francoise <rfrancoise@debian.org>
-Build-Depends: debhelper (>= 9), libattr1-dev
-Standards-Version: 3.9.6
-Homepage: http://david.hardeman.nu/software.php
+Build-Depends: debhelper (>= 11),
+               libattr1-dev,
+               libbsd-dev
+Standards-Version: 4.1.3
+Homepage: https://github.com/przemoc/metastore
+Vcs-Browser: https://salsa.debian.org/rfrancoise/metastore
+Vcs-Git: https://salsa.debian.org/rfrancoise/metastore.git
 
 Package: metastore
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends: ${misc:Depends},
+         ${shlibs:Depends}
 Description: Store and restore metadata from a filesystem
  metastore is a tool to store the metadata of files/directories/links in
  a file tree to a separate file and to later compare and apply the
