=== debian/changelog ===
metastore (1.1.2-2) unstable; urgency=medium

  * Loosen build-dep on debhelper 11 to allow backporting the package to
    stretch-backports.

 -- Romain Francoise <rfrancoise@debian.org>  Thu, 18 Jan 2018 21:01:26 +0100

metastore (1.1.2-1) unstable; urgency=medium

  * New upstream release.
  * Drop Hurd patch, included upstream.
  * Drop LDFLAGS workaround.

 -- Romain Francoise <rfrancoise@debian.org>  Sun, 07 Jan 2018 13:45:35 +0100

metastore (1.1.1a-2) unstable; urgency=medium

  * Pass PREFIX to make via dh_auto_install and drop upstream patch.
  * Remove extra license text installed by the upstream makefile (lintian
    warning).
  * Cherry-pick commit 16cde6c32f from upstream to fix build on Hurd.
  * Work around upstream Makefile which tries to transform LDFLAGS into
    compiler options when they already are.
  * Drop now unnecessary build-dep on libattr1-dev.
  * Always build with V=1.

 -- Romain Francoise <rfrancoise@debian.org>  Fri, 05 Jan 2018 23:57:12 +0100
