=== debian/control ===
--- 
+++ 
@@ -2,8 +2,7 @@
 Section: misc
 Priority: optional
 Maintainer: Romain Francoise <rfrancoise@debian.org>
-Build-Depends: debhelper (>= 11),
-               libattr1-dev,
+Build-Depends: debhelper (>= 11~),
                libbsd-dev
 Standards-Version: 4.1.3
 Homepage: https://github.com/przemoc/metastore
