=== debian/rules ===
--- 
+++ 
@@ -5,5 +5,9 @@
 %:
 	dh $@
 
+override_dh_auto_build:
+	dh_auto_build -- V=1
+
 override_dh_auto_install:
-	PREFIX=/usr dh_auto_install
+	dh_auto_install	-- PREFIX=/usr
+	rm debian/metastore/usr/share/doc/metastore/LICENSE.GPLv2
