=== debian/watch ===
version=4
opts="pgpsigurlmangle=s/$/.asc/" \
http://ftp.przemoc.net/pub/software/utils/metastore/ metastore-(.+)\.tar\.gz
